# -*- coding: utf-8 -*-
"""V3 Word Frequency CN.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/1JNGP3FGazqLZnFuuzF40DuXHEhk_yVuv
"""

import argparse
import pandas as pd
import jieba
from collections import Counter

def preprocess_text(texts, stopwords_path):
    with open(stopwords_path, 'r', encoding='utf-8') as file:
        stopwords = set(file.read().split())
    processed_texts = []
    word_occurrences = Counter()
    for text in texts:
        if not isinstance(text, str):
            text = str(text)
        words = jieba.cut(text)
        filtered_words = [word for word in words if len(word) >= 2 and word not in stopwords and word.strip() != '']
        processed_texts.append(" ".join(filtered_words))
        unique_words = set(filtered_words)
        word_occurrences.update(unique_words)
    return processed_texts, word_occurrences

def main(data_path, stopwords_path, output_path):
    data = pd.read_csv(data_path)
    processed_texts, word_occurrences = preprocess_text(data['Text'], stopwords_path)
    text_series = pd.Series(processed_texts)
    all_words = ' '.join(text_series)
    words_list = all_words.split()
    word_freq = Counter(words_list)
    top_100_words = word_freq.most_common(100)
    df = pd.DataFrame(top_100_words, columns=['Word', 'Frequency'])
    total_posts = len(data['Text'])
    df['Term Frequency'] = df['Word'].apply(lambda x: word_occurrences[x])
    df['Percentage'] = df['Word'].apply(lambda x: round((word_occurrences[x] / total_posts) * 100, 2))
    df.sort_values(by='Term Frequency', ascending=False, inplace=True)
    df.to_csv(output_path, index=False, encoding='utf_8_sig')
    print(df)

if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='Process some texts.')
    parser.add_argument('--data', type=str, required=True, help='Path to the input data file')
    parser.add_argument('--stopwords', type=str, required=True, help='Path to the stopwords file')
    parser.add_argument('--output', type=str, required=True, help='Path to the output file')
    args = parser.parse_args()
    main(args.data, args.stopwords, args.output)